package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.segmentation.OcrRule;
import com.docus.server.entity.segmentation.OcrRuleTest;
import com.docus.server.infrastructure.dao.IOcrRuleDao;
import com.docus.server.infrastructure.mapper.OcrRuleMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 匹配策略表 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-08-29
 */
@Repository
public class OcrRuleDaoImpl extends BaseDaoImpl<OcrRuleMapper, OcrRule> implements IOcrRuleDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public OcrRule findById(Long id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param ocrRule 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(OcrRule ocrRule) {
        return super.save(ocrRule);
    }

    /**
     * 编辑
     *
     * @param ocrRule 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(OcrRule ocrRule) {
        return super.updateById(ocrRule);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<OcrRule> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<OcrRule> query = Wrappers.lambdaQuery();

        Object assortId = searchDTO.getParams("assortId");
        query.eq(OcrRule::getAssortId,assortId);

        //默认createTime倒序排序
        query.orderByDesc(OcrRule::getCreateTime);
        List<OcrRule> list = super.find(query);
        return new PageResult<>(list);
    }

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    @Override
    public int findByIdAndName(Long id, String name) {
        LambdaQueryWrapper<OcrRule> query = Wrappers.lambdaQuery();
        if (id != null) {
            query.ne(OcrRule::getId, id);
        }
        //if (Func.isNotBlank(name)) {
        //   query.eq(OcrRule::getName, name);
        //}

        return baseMapper.selectCount(query);
    }
}
